SystemOrganization addCategory: #ConfigurationOfExample10!

Object subclass: #ConfigurationOfExample10
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfExample10'!

!ConfigurationOfExample10 class methodsFor: 'development support' stamp: 'JPSA 8/8/2012 09:32'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfExample10 class methodsFor: 'private' stamp: 'JPSA 8/8/2012 09:32'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfExample10 class methodsFor: 'private' stamp: 'JPSA 8/8/2012 09:32'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfExample10 class methodsFor: 'private' stamp: 'JPSA 8/8/2012 09:32'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfExample10 class methodsFor: 'metacello tool support' stamp: 'JPSA 8/8/2012 09:32'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfExample10 class methodsFor: 'loading' stamp: 'JPSA 8/8/2012 09:32'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfExample10 class methodsFor: 'loading' stamp: 'JPSA 8/8/2012 09:32'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfExample10 class methodsFor: 'loading' stamp: 'JPSA 8/8/2012 09:32'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfExample10 class methodsFor: 'accessing' stamp: 'JPSA 8/8/2012 09:32'!
project

	^self new project! !

!ConfigurationOfExample10 class methodsFor: 'development support' stamp: 'JPSA 8/8/2012 09:32'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfExample10 methodsFor: 'baselines' stamp: 'JPSA 8/8/2012 09:32'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/VersionnerCacheTest'.
		spec package: 'Example4'.
		spec group: 'default' with: #('Example4' ). ].
! !

!ConfigurationOfExample10 methodsFor: 'symbolic versions' stamp: 'JPSA 8/8/2012 09:32'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfExample10 methodsFor: 'accessing' stamp: 'JPSA 8/8/2012 09:32'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfExample10 methodsFor: 'versions' stamp: 'JPSA 8/8/2012 09:32'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'JPSA'.
		spec timestamp: '8/8/2012 09:32'.
		spec package: 'Example4' with: 'Example4-JPSA.1'. ].
! !
